% Adi Barchan and Kfir Wolfson's Chemical Configuration-Graph Recognizer Project
% Introduction to Computational and Biological Vision Course,
% Ben Gurion University, Israel, Fall 2006

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Press Run (F5) to start program %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
function varargout = main_gui(varargin)
    % Adi and Kfir's project

    % MAIN_GUI M-file for main_gui.fig
    %      MAIN_GUI, by itself, creates a new MAIN_GUI or raises the existing
    %      singleton*.
    %
    %      H = MAIN_GUI returns the handle to a new MAIN_GUI or the handle to
    %      the existing singleton*.
    %
    %      MAIN_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
    %      function named CALLBACK in MAIN_GUI.M with the given input arguments.
    %
    %      MAIN_GUI('Property','Value',...) creates a new MAIN_GUI or raises the
    %      existing singleton*.  Starting from the left, property value pairs are
    %      applied to the GUI before main_gui_OpeningFunction gets called.  An
    %      unrecognized property name or invalid value makes property application
    %      stop.  All inputs are passed to main_gui_OpeningFcn via varargin.
    %
    %      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
    %      instance to run (singleton)".
    %
    % See also: GUIDE, GUIDATA, GUIHANDLES

    
    
    % Begin initialization code - DO NOT EDIT
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
                       'gui_Singleton',  gui_Singleton, ...
                       'gui_OpeningFcn', @main_gui_OpeningFcn, ...
                       'gui_OutputFcn',  @main_gui_OutputFcn, ...
                       'gui_LayoutFcn',  [] , ...
                       'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
    % End initialization code - DO NOT EDIT
end

% --- Executes just before main_gui is made visible.
function main_gui_OpeningFcn(hObject, eventdata, handles, varargin)
    % This function has no output args, see OutputFcn.
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    % varargin   command line arguments to main_gui (see VARARGIN)

    % Choose default command line output for main_gui
    handles.output = hObject;
    % Update handles structure
    guidata(hObject, handles);
    movegui(hObject,'onscreen')% To display application onscreen
    movegui(hObject,'center')  % To display application in the center of screen
    init;
    
    % UIWAIT makes main_gui wait for user response (see UIRESUME)
    % uiwait(handles.figure1);
end

% --- Outputs from this function are returned to the command line.
function varargout = main_gui_OutputFcn(hObject, eventdata, handles) 
    % varargout  cell array for returning output args (see VARARGOUT);
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Get default command line output from handles structure
        varargout{1} = handles.output;
end


% --------------------------------------------------------------------
function OpenMenu_Callback(hObject, eventdata, handles)
    % hObject    handle to OpenMenu (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    [file, pathname] = ...
         uigetfile('*.bmp','Please Select a 1-bit bitmap file');
    filename = [pathname file];
    if ~isequal(file, 0)
        global I STAGE
        set(handles.MainImage,'Visible','on');
        I = read_image(filename);
        show_image(I,handles)
        set(handles.ExtraText,'Visible','off');
        set(handles.NextStageText,'Visible','on');
        set(handles.NextButton,'Visible','on');
        set(handles.OpenMenu,'Enable','off');
    end
end

% --------------------------------------------------------------------
function ExitMenu_Callback(hObject, eventdata, handles)
    % hObject    handle to ExitMenu (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    delete(handles.MainFig)
end

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
    % hObject    handle to FileMenu (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
end

% --- Executes during object creation, after setting all properties.
function NormPopup_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to NormPopup (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: popupmenu controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end

% --- Executes on button press in FindAtomButton.
function FindAtomButton_Callback(hObject, eventdata, handles)
    % hObject    handle to FindAtomButton (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    global DB_levels electrons_in_lvl DB_names DB_orbitals electrons_in_orbital...
        elem_sign elem_name distance elem_orbitals
    distance_norm = get(handles.NormPopup,'value');
    %value is the norm because the values are 1..4, except for 5 which is inf
    if distance_norm == 5
        distance_norm = 100;
    end
    
    %debug
%     electrons_in_orbital

    [distance elem_num] = find_closest_atom(DB_orbitals, electrons_in_orbital, distance_norm);
    elem_sign = DB_names{1,elem_num};
    elem_name = DB_names{2,elem_num};
    elem_orbitals = DB_orbitals(:,elem_num);
    results();
end


% --- Executes on selection change in NormPopup.
function NormPopup_Callback(hObject, eventdata, handles)
    % hObject    handle to NormPopup (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: contents = get(hObject,'String') returns NormPopup contents as cell array
    %        contents{get(hObject,'Value')} returns selected item from NormPopup
end



% --- Executes on button press in NextButton.
function NextButton_Callback(hObject, eventdata, handles)
    % hObject    handle to NextButton (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    global STAGE I horiz_part_of_I MAX_NUM_OF_LEVELS MIN_VOTES_FOR_FULL_IMG d_horiz_lines_full_img...
        d_edge_detection_full_img centers d_clustering NUM_OF_SUB_LEVELS_IN_LEVEL Horiz_Lines...
        sub_images d_sub_levels SUB_LEVEL_HALF_WIDTH_PERCENTAGE electrons_in_orbital d_edge_detection_sub_img...
        MIN_VOTES_FOR_SUB_IMG MAX_NUM_OF_ELECTRONS_PER_SUB_LVL d_horiz_lines_sub_img ...
        electrons_in_lvl MAX_NUM_OF_SUB_LEVELS electrons_in_orbital
    
    STAGE = STAGE + 1;
    switch STAGE
        case 1
            %     Stage1: Edge Detection of horzontal lines
            set(handles.StageText,'String',...
                'Stage I - Edge Detection of horzontal lines: Prewitt Edge Detector');
            horiz_part_of_I = horiz_edge_det(I, d_edge_detection_full_img);
            show_image(horiz_part_of_I, handles);
        case 2
            %     Stage II - Horizontal lines detection: Hough transform
            set(handles.StageText,'String',...
                'Stage II - Horizontal lines detection using Hough transform');
            set(handles.ExtraText,'String',...
                'Drawing lines over original image');
            set(handles.ExtraText,'Visible','on');
        
            %if want to limit num of lines use MAX_NUM_OF_LEVELS instead of 0
            Horiz_Lines = detect_horizontal_lines(horiz_part_of_I, ...
                    0, MIN_VOTES_FOR_FULL_IMG, d_horiz_lines_full_img);
            
            Horiz_Lines = sort(Horiz_Lines, 'descend');
            show_image_and_horiz_lines(I,Horiz_Lines,handles);
            
            levels_correctness = check_horizontal_levels(Horiz_Lines, MAX_NUM_OF_LEVELS);
            if (levels_correctness.num_of_levels == 0)
                 msgbox(['The number of levels is greater than ' int2str(MAX_NUM_OF_LEVELS)],'Drawing Error','error');
                 set(handles.NextButton,'Enable','off');
            elseif (levels_correctness.distance == 0) 
                 msgbox('The levels are too far apart','Drawing Error','error');
                 set(handles.NextButton,'Enable','off');
            end

        case 3
            %     Stage III - Find centers of Sub-Electon-Levels: K-Clustering
            set(handles.StageText,'String',...
                'Stage III - Find centers of Orbitals using K-Clustering method');
            set(handles.ExtraText,'String',...
                'Colored lines mark boundaries of pixel locations for each K-Clustering algorithm run');
            centers = centers_of_lines(Horiz_Lines,I,d_clustering, NUM_OF_SUB_LEVELS_IN_LEVEL); 
            show_image_and_centers(I, centers, handles);
            
             % test for vetrical correctness: %
            
            vertical_correctness = check_vertical(centers ,length(Horiz_Lines) ,NUM_OF_SUB_LEVELS_IN_LEVEL);
            %vertical_correctness = struct('num_of_sub_levels',{0},'first_row',{0},
            %                       'second_row',{0},'third_row',{0},'forth_row',{0});

            if vertical_correctness.num_of_sub_levels == 0
                msgbox('the number of sub levels is not consistent with the number of levels!',...
                        'Logical Error','error');
                 set(handles.NextButton,'Enable','off');
            end
            
            warnings = '';
            if vertical_correctness.first_row == 0
                warnings = [warnings 'the first column is not aligned  '];
            end 
            if vertical_correctness.second_row == 0
                warnings = [warnings 'the second column is not aligned  '];
            end 
            if vertical_correctness.third_row == 0
                warnings = [warnings 'the third column is not aligned  '];
            end 
            if vertical_correctness.forth_row == 0
                warnings = [warnings 'the forth column is not aligned  '];
            end

            if ~(strcmp(warnings,''))
                msgbox (['Warning: ' warnings],'Warning','warn');
            end
            
            
        case 4
            %     Stage IV - Segment image into small sub-images with each orbital
            set(handles.StageText,'String',...
                'Stage IV - Segment image into small sub-images with each orbital');
            set(handles.ExtraText,'Visible','off')
            sub_images = segment_image_to_sub_levels(I, Horiz_Lines, centers,...
                    d_sub_levels, SUB_LEVEL_HALF_WIDTH_PERCENTAGE, NUM_OF_SUB_LEVELS_IN_LEVEL);
            %sub_images is a vector of structs
            show_sub_images(I, sub_images, handles);
        case 5
            %     Stage V - Num of electrons in each sub-lvl. detect and count vertical lines in each sub image
            set(handles.StageText,'String',...
                'Stage V - Num of electrons in each orbital');
            set(handles.ExtraText,'String',...
                'Count vertical lines in each sub-image, by trasposing and counting horizontal ones');
            set(handles.ExtraText,'Visible','on');
            electrons_in_orbital = detect_num_of_vert_lines_in_each_sub_img (sub_images,...
                                    d_edge_detection_sub_img, MAX_NUM_OF_ELECTRONS_PER_SUB_LVL,...
                                    MIN_VOTES_FOR_SUB_IMG, d_horiz_lines_sub_img, handles);
            %pad vector with 0's, as needed for later calculations
            electrons_in_orbital = extend_vector(electrons_in_orbital,MAX_NUM_OF_SUB_LEVELS);          
            
           
            
        case 6
            %     Stage VI - Compare findings with chemical element database:
            set(handles.StageText,'String',...
                'Stage VI - Compare findings with chemical element database');
            set(handles.ExtraText,'String',...
                'Click to calc distance (in amount of electrons per level), according to norm');
            
%             electrons_in_lvl = sum_electrons_in_lvls(electrons_in_orbital);
            
            set(handles.NextStageText,'String','Choose norm to work with:');
            set(handles.NormPopup,'Visible','on')
            set(handles.FindAtomButton,'Visible','on')
            set(handles.NextButton,'Visible','off')
            
            %continues when user presses FindAtomButton
            
    end
end


% % % % % % % % % % % %   NON-GUI CODE   % % % % % % % % % 

function init()
    
    % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %     
    % Global Constants
    global NUM_OF_SUB_LEVELS_IN_LEVEL
    global MAX_NUM_OF_SUB_LEVELS
    global d_edge_detection_full_img   % delta for prewitt edge detector (full img)
    global d_edge_detection_sub_img % delta for prewitt edge detector (each sub_image)
    global d_horiz_lines_full_img   % range for "a" or line to be treated as 0 (full img), f: detect_horizontal_lines:
    global d_horiz_lines_sub_img    % range for "a" or line to be treated as 0 (each sub_image), f: detect_horizontal_lines:
    global MIN_VOTES_FOR_FULL_IMG % minimal votes for a line (full img), f: detect_horizontal_lines:
    global MIN_VOTES_FOR_SUB_IMG     % minimal votes for a line (each sub_image), f: detect_horizontal_lines:
    global d_clustering 
    global d_sub_levels     % how much to take below horiz_line as sub level 
    global MAX_NUM_OF_LEVELS 
    global MAX_NUM_OF_ELECTRONS_PER_SUB_LVL 
    global SUB_LEVEL_HALF_WIDTH_PERCENTAGE  
    global DISTANCE_NORM  % norm for vector-distances of mesured electron ammount to real elements
    global DB_levels DB_orbitals DB_names %element database
    global I  %image
    global STAGE
    
    NUM_OF_SUB_LEVELS_IN_LEVEL = [1 1 3 1 3];
    MAX_NUM_OF_SUB_LEVELS = 9;
    d_edge_detection_full_img = 0.2;   % delta for prewitt edge detector (full img)
    d_edge_detection_sub_img = 0.05;   % delta for prewitt edge detector (each sub_image)
%     d_edge_detection_sub_img = 0.2;
    d_horiz_lines_full_img = 10;  % minimal distance between 2 lines (full img), f: detect_horizontal_lines:
    d_horiz_lines_sub_img = 3;    % minimal distance between 2 lines (each sub_image), f: detect_horizontal_lines:
    MIN_VOTES_FOR_FULL_IMG = 15;  % minimal votes for a line (full img), f: detect_horizontal_lines:
    MIN_VOTES_FOR_SUB_IMG = 7;    % minimal votes for a line (each sub_image), f: detect_horizontal_lines:
    d_clustering = 20;
    d_sub_levels = 20;        % how much to take below horiz_line as sub level 
    MAX_NUM_OF_LEVELS = 5;
    MAX_NUM_OF_ELECTRONS_PER_SUB_LVL = 2;
    SUB_LEVEL_HALF_WIDTH_PERCENTAGE = 1/10;  
    DISTANCE_NORM = 2;  % norm for vector-distances of mesured electron ammount to real elements
    STAGE = 0;
    % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
    
    [DB_names DB_levels DB_orbitals] = read_db_from_file();
end

function [DB_names DB_levels DB_orbitals] = read_db_from_file()
    fid = fopen('elements_names.csv');
    names = textscan(fid, '%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s',...
                     'delimiter', ',', 'whitespace', '');
    fclose(fid);
    fid = fopen('elements_levels.csv');
    levels = textscan(fid, '%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d',...
                    'delimiter', ',', 'whitespace', '');
    fclose(fid);
    fid = fopen('elements_orbitals.csv');
    orbitals = textscan(fid, '%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d',...
                    'delimiter', ',', 'whitespace', '');
    fclose(fid);
    DB_names = [];
    DB_levels = [];
    DB_orbitals = [];
    for i = 1:size(names,2)
        DB_names = [DB_names, names{i}];
        DB_levels = [DB_levels, levels{i}];
        DB_orbitals = [DB_orbitals, orbitals{i}];
    end
    DB_orbitals = double(DB_orbitals);
    DB_levels = double(DB_levels);
end


function show_image(I, handles)
%shows the image in main image
    map =[0 0 0
          1 1 1];
    colormap(map);
    
%     set(handles.axes3,'HandleVisibility','OFF')
    axes(handles.MainImage);
    set(handles.MainImage,'HandleVisibility','ON') 
    image(~I);
    set(handles.MainImage,'XTickLabel',' ','YTickLabel',' ');
end

function show_image_and_horiz_lines(I, Horiz_Lines,handles);
    %show image I
    show_image(I,handles);
    hold on
    [size_y size_x] = size(I);    
    %plot all Horiz lines on it:
    x = [0 size_x];
    for line = 1:size(Horiz_Lines,2)
        y = [Horiz_Lines(line) Horiz_Lines(line)];
        plot(x,y)
    end
end

function show_image_and_vert_lines(I, Horiz_Lines,handles);
    %show image I
%     show_image(I,handles);
     map =[0 0 0
          1 1 1];
    colormap(map);
    image(~I);
    hold on
    [size_y size_x] = size(I);    
    %plot all Horiz lines on it:
    y = [0 size_y];
    for line = 1:size(Horiz_Lines,2)
        x = [Horiz_Lines(line) Horiz_Lines(line)];
        plot(x,y)
    end
end

function show_image_and_centers(I, list_of_centers,handles); 
    global d_clustering Horiz_Lines
    hold off
    %show image I
    show_image(I,handles);
    hold on
    [size_y size_x] = size(I);    
    
    %plot boundaries of horizontal areas in I for K clustering:
    x = [0 size_x];
    colors = ['b' 'm' 'c' 'g' 'r'];
    for line = 1:size(Horiz_Lines,2)
        col = colors(mod(line,size(colors,2))+1);
        yval = Horiz_Lines(line)-2*d_clustering;
        if (yval > 0)
            y = [yval yval];
            plot(x,y,col);
        end
        yval = Horiz_Lines(line)+d_clustering;
        if (yval <= size_y)
            y = [yval yval];
            plot(x,y,col);
        end
    end

    %plot centers
    plot(list_of_centers(:,1), list_of_centers(:,2),'or');
end


function show_sub_images(I, sub_images, handles);
    hold off
%     show_image(sub_images(1).image,handles);
    map =[0 0 0
          1 1 1];
    colormap(map);
    axes(handles.MainImage);
    image(~[0]);
    set(handles.MainImage,'Visible','off')
    set(handles.SubImg1,'Visible','ON');
    axes(handles.SubImg1);
    image(~sub_images(1).image);
    set(handles.SubImg1,'XTickLabel',' ','YTickLabel',' ');
    set(handles.SubImg2,'Visible','ON');
    if size(sub_images,2) < 2
        return
    end
    axes(handles.SubImg2);
    image(~sub_images(2).image);
    set(handles.SubImg2,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 3
        return
    end
    set(handles.SubImg3,'Visible','ON');
    axes(handles.SubImg3);
    image(~sub_images(3).image);
    set(handles.SubImg3,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 4
        return
    end
    set(handles.SubImg4,'Visible','ON');
    axes(handles.SubImg4);
    image(~sub_images(4).image);
    set(handles.SubImg4,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 5
        return
    end
    set(handles.SubImg5,'Visible','ON');
    axes(handles.SubImg5);
    image(~sub_images(5).image);
    set(handles.SubImg5,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 6
        return
    end
    set(handles.SubImg6,'Visible','ON');
    axes(handles.SubImg6);
    image(~sub_images(6).image);
    set(handles.SubImg6,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 7
        return
    end
    set(handles.SubImg7,'Visible','ON');
    axes(handles.SubImg7);
    image(~sub_images(7).image);
    set(handles.SubImg7,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 8
        return
    end
    set(handles.SubImg8,'Visible','ON');
    axes(handles.SubImg8);
    image(~sub_images(8).image);
    set(handles.SubImg8,'XTickLabel',' ','YTickLabel',' ');
    if size(sub_images,2) < 9
        return
    end
    set(handles.SubImg9,'Visible','ON');
    axes(handles.SubImg9);
    image(~sub_images(9).image);
    set(handles.SubImg9,'XTickLabel',' ','YTickLabel',' ');
    
%     axes(handles.MainImage);
end



% Stage 0 %
% ------- %

function I = read_image(filename)
    I = double(imread(filename));
    I = ~I;    % switch white and black
end


% Stage I %
% ------- %

function answer = horiz_edge_det(I, thresh)
    % prewit edge detection of horitontal lines
    kernel=1/6* [-1 0 1
                 -1 0 1
                 -1 0 1];
    p1  = filter2(kernel,I);
    kernel = kernel';
    p2  = filter2(kernel,I);
    % to remove div by zero warnings:
    p1 = p1+0.0000000001;
    %calculate Argument and Magintude of edges
    Arg = (atan(-p2./p1));
    Mag = sqrt((p1.^2+p2.^2));
    Edges = (Mag>=thresh);
    Horiz_Edges = ((Edges) & (Arg >= 80/180*pi) & (Arg <= 90/180*pi));
    answer = Horiz_Edges;
end
            
% Stage II % 
% -------- %

function Horiz_Lines = detect_horizontal_lines(I, max_lines, MIN_VOTES, delta)
%Hough line detection of type (a,b) (for lines of type y=ax+b)
% if max_lines == 0 then no limit to the number of lines

    [size_x size_y] = size(I);
    a_min = -99;
    a_max = 100;
    kalfi_size_a = a_max - a_min + 1; % 200
    b_min = 1;
    b_max = size_y;
    kalfi_size_b = b_max - b_min + 1; 
    Kalfi = zeros(kalfi_size_a, kalfi_size_b);
    for y = 1:size_x
        for x = 1:size_y
            if (I(y,x) > 0)
                for a = a_min:a_max
                    b = floor((-x) * a + y);
                    if (b_min <= b) && (b <= b_max)
                        Kalfi(a-a_min+1,b) = Kalfi(a-a_min+1,b) + 1;
                    end
                end
            end
        end
    end
    
% 	for all values of a in [-delta, delta], find local maximas of b's (for
% 	a certain "a" value) - maxima in the same line ("a")
    a0 = 0 - a_min;
    %  delta is an input to the function
     a_range = [a0-delta : a0+delta];

    K1 = Kalfi(a_range,:)';   % transpose is needed to get the
                              % indices correct, for K1(i)
    %flatten the Kalfi to a single line vector:
    K = K1(:)';
    %K is now a flattened vector of Kalfi (row after row)
        
    [sK Max_Bs] = sort(K,2,'ascend'); %sort K and save indices in Max_Bs
    % the Indices of the K array are the b values
    % that still need to be modulo'd by the maximum b value:
    Max_Bs = mod(Max_Bs, kalfi_size_b); 
    
    %remove lines with a very low num of votes
    sK1 = [];
    Max_Bs1 = [];
    for i = 1:size(sK,2)
        if (sK(i) >= MIN_VOTES)
            sK1 = [sK1 sK(i)];
            Max_Bs1 = [Max_Bs1 Max_Bs(i)];
        end
    end
        
    if size(sK1) == 0 %if we we found no line, (sK1 is empty)
        Horiz_Lines = [];
        return
    end
    
    %remove lines ("b"s) that are too close (minimum distance = 2*delta)
    sK2 = sK1(1);
    Max_Bs2 = Max_Bs1(1);    
    for i = 2:size(Max_Bs1,2)
        b = Max_Bs1(i);
        not_too_close = 1;
        j = 1;
        while (j < i) && not_too_close  %go over all the lines already in Max_Bs2 ("found")
            if abs(Max_Bs1(j) - b) < 2*delta 
                % and if line b is too close to any line already found
                % mark it as such
                not_too_close = 0;
            end
            j = j + 1;
        end
        if not_too_close
                Max_Bs2 = [Max_Bs2 b]; %insert it into Max_Bs2 (it is now "found")
%                 sK2 = [sK2 sK1(i)];    %not sure if this is needed any more!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1111
                %!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        end
    end
    
    % if max_lines == 0 then no limit to the number of lines
    if (max_lines > 0) & (size(Max_Bs2,2) > max_lines)
        Horiz_Lines = Max_Bs2(1:max_lines);
    else
        Horiz_Lines = Max_Bs2;
    end             
end
        

% Stage III % 
% --------- %

function list_of_centers = centers_of_lines(Horiz_Lines,I,d_clustering, NUM_OF_SUB_LEVELS_IN_LEVEL)
% This function takes a list of horizontal lines (electron levels), and
% returns the centers of each sub-level, using the K-Clustering method.
% 
% Input:
%  - Horiz-Lines = list of horizonal lines returned by
%                  "detect_horizontal_lines"
%  - I = the Image
%  - d_clustering = a "delta" value - the num of lines above and under the
%                   horizontal line.
% Returns:
%  - list_of_centers = a (n x 2) matrix. 
%                      1st column is X value, 2nd col is Y value of centers
% 
% Usage:   centers_of_lines(Horiz_Lines,I,d_clustering)
% 

    [size_y size_x] = size(I);
    num_of_lines = size(Horiz_Lines,2);
    list_of_centers =[];
    
    for i = 1 : num_of_lines
        B = Horiz_Lines(i);
        % take the lines around B in I, twice as much above B than below,
        % using d_clustering value
        I_segment = I(max(B - 2*d_clustering,0) : min(B + d_clustering,size_y),:); 
        [y_ind, x_ind] = find(I_segment);
        fcmdata = [x_ind y_ind];

        op = [NaN NaN NaN 0]; %to prevent fcm function printing info
        [centers, U, obj_fcn] = fcm(fcmdata, NUM_OF_SUB_LEVELS_IN_LEVEL(i),op);
%       redo if fcm didn't find the centers (got NaN)
        while (~all(finite(centers)))
            [centers, U, obj_fcn] = fcm(fcmdata, NUM_OF_SUB_LEVELS_IN_LEVEL(i),op);
        end
           
%       add the correct offset to the Y column of the I_segment:
        centers(:,2) = centers(:,2) + B - 2*d_clustering;        
        centers = sortrows(centers); % sort center points by X value - to maintain the order we are used to.      
        list_of_centers = [list_of_centers ; centers];
    end
end
            

% Stage IV % 
% -------- %

function sub_images = segment_image_to_sub_levels(I, Horiz_Lines, centers, d_sub_levels, SUB_LEVEL_HALF_WIDTH_PERCENTAGE, NUM_OF_SUB_LEVELS_IN_LEVEL)
    [size_y size_x] = size(I);
    % substract a delta from the Horiz_Lines, and use for all boundries
    new_Horiz_Lines = Horiz_Lines + d_sub_levels; 

    counter_of_sub_levels = 1;
    num_of_levels = size(Horiz_Lines,2);
    for current_level = 1 : num_of_levels
        for current_sub_level = 1 : NUM_OF_SUB_LEVELS_IN_LEVEL(current_level)
            % ("lower" in the graphical meaning, when displaying I)
            lower_bound = min(new_Horiz_Lines(current_level), size_y);

            if current_level < num_of_levels % if there are still levels "above us"
                upper_bound = new_Horiz_Lines(current_level+1);
            else
                upper_bound = 1;
            end

            left_bound  = max(centers(counter_of_sub_levels,1) - int16(SUB_LEVEL_HALF_WIDTH_PERCENTAGE * size_x), 1);
            right_bound = min(centers(counter_of_sub_levels,1) + int16(SUB_LEVEL_HALF_WIDTH_PERCENTAGE * size_x), size_x);
            
            % cut out the sub-image between the boundries:         
            sub_image = I(upper_bound:lower_bound, left_bound:right_bound);
            sub_images(counter_of_sub_levels).upper = upper_bound;
            sub_images(counter_of_sub_levels).lower = lower_bound;
            sub_images(counter_of_sub_levels).left  = left_bound;
            sub_images(counter_of_sub_levels).right = right_bound;           
            sub_images(counter_of_sub_levels).image = sub_image;           
            counter_of_sub_levels = counter_of_sub_levels + 1;
        end
    end
end


% Stage V % 
% ------- %

function electrons_in_orbital = detect_num_of_vert_lines_in_each_sub_img (sub_images,...
            d_edge_detection_sub_img, MAX_NUM_OF_ELECTRONS_PER_SUB_LVL,...
            MIN_VOTES_FOR_SUB_IMG, d_horiz_lines_sub_img, handles)
% detect_num_of_vert_lines_in_each_sub_img 
% counts number of vertical lines in each sub-image, and returns a vector
% of numbers (values between 0 and 2)
% output:  vector such that: electrons_in_orbital[i] = number of vert lines
%                                                      in sub_img i


    electrons_in_orbital = [];
    for i = 1 : size(sub_images,2);
        Sub_I = sub_images(i).image;
        Sub_I = Sub_I'; % transposing and looking for horiz. lines to find vert. lines
        Horiz_part_of_sub_image = horiz_edge_det(Sub_I,d_edge_detection_sub_img);
        
%         debug
%          figure, imshow(~Horiz_part_of_sub_image);
        
        Horiz_Lines = detect_horizontal_lines(Horiz_part_of_sub_image,...
                        MAX_NUM_OF_ELECTRONS_PER_SUB_LVL, ...
                        MIN_VOTES_FOR_SUB_IMG, d_horiz_lines_sub_img);
%         Horiz_Lines = sort(Horiz_Lines, 'descend');
        electrons_in_orbital = [electrons_in_orbital; size(Horiz_Lines,2)];
        
%         %debug
%         if i == 6
%             axes(handles.axes3);
% 
%             show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
% %             show_image(Horiz_part_of_sub_image, handles);
% %             figure, imshow(~Horiz_part_of_sub_image);
%         end
        switch i
            case 1 
                axes(handles.SubImg1);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg1,'XTickLabel',' ','YTickLabel',' ');
            case 2
                axes(handles.SubImg2);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg2,'XTickLabel',' ','YTickLabel',' ');
            case 3 
                axes(handles.SubImg3);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg3,'XTickLabel',' ','YTickLabel',' ');
            case 4
                axes(handles.SubImg4);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg4,'XTickLabel',' ','YTickLabel',' ');
            case 5 
                axes(handles.SubImg5);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg5,'XTickLabel',' ','YTickLabel',' ');
            case 6
                axes(handles.SubImg6);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg6,'XTickLabel',' ','YTickLabel',' ');
            case 7 
                axes(handles.SubImg7);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg7,'XTickLabel',' ','YTickLabel',' ');
            case 8
                axes(handles.SubImg8);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg8,'XTickLabel',' ','YTickLabel',' ');
            case 9
                axes(handles.SubImg9);
                show_image_and_vert_lines(Sub_I',Horiz_Lines,handles);
                set(handles.SubImg9,'XTickLabel',' ','YTickLabel',' ');
        end
    end
end   
         
function ans = extend_vector(vec,to_size)
    % extends vec to be of size "size", by padding with zeros at the end
    % @pre: vec is a vector. size is an integer
    vec_size = size(vec,1);
    ans = zeros(1,to_size);
    ans(1:vec_size) = vec(1:vec_size);
end


% Stage VI % 
% -------- %

function [distance elem_num] = find_closest_atom(Data,Vect,NORM)
    % find closest atom, using norm "NORM" and return index and distance from it
    % 0 = exact match
    % (finds the closest column in Data matrix to Vect)
    % Vect is a row vector, and is tranposed here:
    Vect = Vect';
    dist = [];
    for col = 1:size(Data,2)
        dist(col) = (sum(abs(Data(:,col) - Vect).^NORM)).^(1/NORM);
    end
    [distance elem_num] = min(dist);
end


function electrons_in_lvl = sum_electrons_in_lvls(electrons_in_orbital)
    %    Sum up the num of electrons in each lvl (according to the sub-level count)
    global MAX_NUM_OF_LEVELS NUM_OF_SUB_LEVELS_IN_LEVEL 
    sub_lvl = 1;
    electrons_in_lvl = zeros(1,MAX_NUM_OF_LEVELS);
    for lvl = 1 : MAX_NUM_OF_LEVELS
        electrons_in_lvl(lvl) = sum(sum(electrons_in_orbital...
            (sub_lvl : sub_lvl + NUM_OF_SUB_LEVELS_IN_LEVEL(lvl) - 1)));
        sub_lvl = sub_lvl + 1;
    end
end

 
 

%   Tests  %
% --------- %

function ans = check_horizontal_levels(levels,max_level)
% returns 0 in 'num_of_levels' if too many, and 0 in 'distance' if lines
% are too apart
    ans = struct('num_of_levels',{0},'distance',{0});
    n = length (levels);
    a = [];
    if (n > max_level)
        ans.num_of_levels = 0;  % true = 1, false = 0.
    else
        ans.num_of_levels = 1;
    end
    for i=1:n-1
        a(i) = levels(i)-levels(i+1);
    end
    min_difference = min(a);
    max_difference = max(a);
%     if (max_difference - min_difference) <= 40 %+- 20 
    if (max_difference/min_difference <= 2)
        ans.distance = 1;
    else 
        ans.distance = 0;
    end
end




function ans = check_vertical(centers,num_of_levels,NUM_OF_SUB_LEVELS_IN_LEVEL)
    
    ans = struct('num_of_sub_levels',{0},'first_row',{0},'second_row',{0},'third_row',{0},'forth_row',{0});
    n = length (centers);
    a = [];

    %checking if the num of centers are same as suppose to be according to
    %num of levels
    if ((n <= sum(NUM_OF_SUB_LEVELS_IN_LEVEL(1:num_of_levels))) & (n > sum(NUM_OF_SUB_LEVELS_IN_LEVEL(1:(num_of_levels-1)))))
        ans.num_of_sub_levels = 1;  % true = 1 (->as suppose to be), false = 0.
    else
        ans.num_of_sub_levels = 0;
    end

    %%checking that the first row is alignment
    %x_centers - is the x coordinate of the centers
    x_centers = centers(1 : n);
%     ans.first_row = 0;
%     ans.second_row = 0; 
%     ans.third_row = 0;
%     ans.forth_row = 0;
    
    if (n == 1) %only one level
        ans.first_row = 1;
        ans.second_row = 1; %there are no 2/3/4 rows 
        ans.third_row = 1;
        ans.forth_row = 1;
    end
    % 2-3 levels 
    if ( (n >= 2) && (n <= 5) )
        if( abs(x_centers(1) - x_centers(2)) <= 20)
            ans.first_row = 1;
        end
        ans.second_row = 1; %there is only on object in the second row
        ans.third_row = 1;  %there is only on object in the third row
        ans.forth_row = 1;  %there is only on object in the third row
    end
    % 4-5 levels
    if ( (n >= 6) && (n <= 9))
        a(1) = abs(x_centers(1) - x_centers(2));
        a(2) = abs(x_centers(1) - x_centers(6));
        a(3) = abs(x_centers(2) - x_centers(6));
        if ((a(1) <= 20) && (a(2) <= 20) && (a(3) <= 20))
            ans.first_row = 1;
        end
        if (n <= 8)
            ans.forth_row = 1;%there is no 4th row
            if (n <= 7)
                ans.third_row = 1; %there are no 3/4 rows 
                if (n == 6)
                    ans.second_row = 1; %there are no 2/3/4 rows 
                end
            end
        end
        
        if ((n >= 7) && (abs(x_centers(3) - x_centers(7)) <= 20) ) 
            ans.second_row = 1;
        end
        if ((n >= 8) && (abs(x_centers(4) - x_centers(8)) <= 20) ) 
            ans.third_row = 1;
        end
        if ((n == 9) && (abs(x_centers(5) - x_centers(9)) <= 20) ) 
            ans.forth_row = 1;
        end
    end    
end

